package game.gui;

import game.Game;
import game.inventory.ContainerChest;
import game.inventory.IInventory;


public class GuiChest extends GuiContainer
{
//    /** The ResourceLocation containing the chest GUI texture. */
//    private static final String CHEST_GUI_TEXTURE = "textures/gui/generic_54.png";
    private IInventory upperChestInventory;
    private IInventory lowerChestInventory;

    /**
     * window height is calculated with these values; the more rows, the heigher
     */
    private int inventoryRows;

    public GuiChest(IInventory upperInv, IInventory lowerInv)
    {
        super(new ContainerChest(upperInv, lowerInv, Game.getGame().thePlayer));
        this.upperChestInventory = upperInv;
        this.lowerChestInventory = lowerInv;
//        this.allowUserInput = false;
        int i = 222;
        int j = i - 108;
        this.inventoryRows = lowerInv.getSizeInventory() / 9;
        this.ySize = j + this.inventoryRows * 18;
    }

    /**
     * Draw the foreground layer for the GuiContainer (everything in front of the items). Args : mouseX, mouseY
     */
    public void drawGuiContainerForegroundLayer()
    {
        this.drawString(this.lowerChestInventory.getCommandName(), 8, 6);
        this.drawString(this.upperChestInventory.getCommandName(), 8, this.ySize - 96 + 2);
    }

    /**
     * Args : renderPartialTicks, mouseX, mouseY
     */
//    protected void drawGuiContainerBackgroundLayer(int mouseX, int mouseY)
//    {
//        GlState.color(1.0F, 1.0F, 1.0F, 1.0F);
//        this.gm.getTextureManager().bindTexture(CHEST_GUI_TEXTURE);
//        int i = (this.width - this.xSize) / 2;
//        int j = (this.height - this.ySize) / 2;
////        this.rect(i, j, 0, 0, this.xSize, this.inventoryRows * 18 + 17);
////        this.rect(i, j + this.inventoryRows * 18 + 17, 0, 126, this.xSize, 96);
//    }
}
